﻿<?xml version="1.0" encoding="utf-8"?>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>mono-api-type.html</title>
    <style type="text/css">
    .mapi-docs {
	line-height: 1.5;
	padding-left: 2em;
	padding-right: 2em;
    }
    .mapi-docs p {
	max-width: 60em;
    }
    .mapi-docs .mapi-body {
	max-width: 60em;
    }
    .mapi-docs code {
        border: 1px solid rgba(214,214,214,1);
	background-color: rgba(249,249,249,1);
	padding: 0.1em 0.5em;
    }
    .mapi-description code {
        font-family: "Consolas", "Courier", monospace;
        border: 1px solid rgba(214,214,214,1);
	background-color: rgba(249,249,249,1);
	padding: 0.1em 0.2em;
    }

    .mapi-header {
        padding: 0 0 5pt 5pt;
        margin: 10pt;
        white-space: pre;
        font-family: monospace;
        border: 1px solid rgba(233,233,233,1);
	background-color: rgba(249,249,249,1);
    }

    .mapi-code {
        padding: 5pt 5pt;
        margin: 10pt;
        white-space: pre;
        font-family: monospace;
        border: 1px solid rgba(233,233,233,1);
	background-color: rgba(249,249,249,1);
    }

    .mapi-code:first-line {
        line-height: 0px;
    }

    .mapi-codeblock {
        display: block;
        padding: 5pt 5pt;
        margin: 10pt;
        white-space: pre;
        font-family: monospace;
        border: 1px solid rgba(233,233,233,1);
        background-color: rgba(249,249,249,1);
    }

    .mapi-entry code {
        border: none;
        background-color: transparent;
    }
    
    .mapi-parameters {
        border-collapse: collapse;
        border-spacing: 0;
        empty-cells: hide;
        border: 0;
        margin: 5px 0 26px;	    
    }

    .mapi-parameters td {
        border: 1px solid rgba(214,214,214,1);
	  border-left-style: none;
	padding: 5px 25px 5px 10px;
    }

    .mapi-parameters tr>td:last-child  {
        border-right: 0;
    }
	
    .mapi-parameters td:first-of-type {
        text-align: right;
        padding: 7px;
        vertical-align: top;
        word-break: normal;
        width: 40px;
    }

    .mapi-parameters tr:last-child>td {
        border-bottom: 0;
    }

    .mapi-parameters tr:first-child>td {
        border-top: 0;
    }

    .mapi-parameters tr td:first-of-type {
        text-align: right;
        padding: 7px;
        vertical-align: top;
        word-break: normal;
        width: 40px;
    }

   .mapi {
        left: -25px;
        margin: 0;
        padding: 13px 25px 0;
        position: relative;
        width: 100%;
    } 

    .mapi-description {
        background: rgba(249,249,249,1);
        border-bottom: 1px solid rgba(233,233,233,1);
        left: -25px;
        margin: 0;
        padding: 13px 25px 0;
        position: relative;
        width: 100%;	 
    }

     .mapi-entry {
         background: transparent;
     }

     .mapi-docs {
     }
	
     .mapi-prototype {
         border-left: 5px solid rgba(205,233,244,1);
         padding: .5em;
         margin-top: 5pt;
         margin-bottom: 5pt;
         font-family: "Consolas", "Courier", monospace;
         display: block;
         overflow: auto;
         background-color: #f9f9f9;
    } 

    .mapi-declaration {
	margin-top: 21px;
    }

    .mapi-section {
        font-size: smaller;
	font-weight: bold;
	margin-top: 21px;
	line-height: 1.5;
    }
	
    .mapi-strike {
        text-decoration: line-through;
    }

    .mapi-deprecated {
        color: red;
    }

    .mapi-ptr-container {
        background: white;
	border-bottom: 1px solid rgba(233,233,233,1);
        left: -25px;
        padding-left: 25px;
        padding-right: 25px;
        padding-bottom: 13px;
        position: relative;
        width: 100%;
    }

    .mapi-ptr {
        background: rgba(249,249,249,1);
	border-left: 1px solid rgba(233,233,233,1);
	border-top: 1px solid rgba(233,233,233,1);
        height: 12px;
        left: 37px;
        top: -7px;
        -webkit-transform: rotate(45deg);
        -moz-transform: rotate(45deg);
        -o-transform: rotate(45deg);
        transform: rotate(45deg);
        position: absolute;
        width: 12px;
    }

    .mapi-height-container {
        left: -25px;
        padding: 0 25px;
        position: relative;
        width: 100%;
    }
	
</style>
</head>
<body>
<div class="mapi-docs">
<h2>Type support</h2>

<h3>Synopsis</h3>

	<div class="mapi-header">
#include &lt;metadata/metadata.h&gt;
#include &lt;metadata/class.h&gt;

typedef struct _MonoType MonoType;

	
	</div>

	<p />The MonoType represents the unmanaged version of
	System.Type.
	
<a name="api:mono_type_get_object"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_get_object</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">MonoReflectionType*
mono_type_get_object (MonoDomain *domain, MonoType *type)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>domain</i></td><td> an app domain</td></tr><tr><td><i>type</i></td><td> a type</td></tr></tbody></table>             <div class="mapi-section">Return value</div>
             <div>	 A <code>System.MonoType</code> object representing the type <i>type</i>.
</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_create_from_typespec"></a>
<div class="mapi">
    <div class="mapi-entry mapi-strike"><code>mono_type_create_from_typespec</code></div><br /><div class='mapi-deprecated'><b>Deprecated:</b>  use <code>mono_type_create_from_typespec_checked</code> that has proper error handling</div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">MonoType*
mono_type_create_from_typespec (MonoImage *image, guint32 type_spec)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>image</i></td><td> context where the image is created</td></tr><tr><td><i>type_spec</i></td><td>  typespec token</td></tr></tbody></table>             <div class="mapi-section">Description</div>
             <div>
<p />
 Creates a <code>MonoType</code> representing the <code>TypeSpec</code> indexed by the <i>type_spec</i>
 token.</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_full_name"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_full_name</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">char*
mono_type_full_name (MonoType *type)

</div>
            <p />
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_get_array_type"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_get_array_type</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">MonoArrayType*
mono_type_get_array_type (MonoType *type)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>type</i></td><td> the <code>MonoType</code> operated on</td></tr></tbody></table>             <div class="mapi-section">Return value</div>
             <div>	 a <code>MonoArrayType</code> struct describing the array type that <i>type</i>

	 represents. The info includes details such as rank, array element type
	 and the sizes and bounds of multidimensional arrays.</div>
             <div class="mapi-section">Description</div>
             <div>
 It is only valid to call this function if <i>type</i> is a <code>MONO_TYPE_ARRAY</code> .</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_get_class"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_get_class</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">MonoClass*
mono_type_get_class (MonoType *type)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>type</i></td><td> the <code>MonoType</code> operated on</td></tr></tbody></table>             <div class="mapi-section">Return value</div>
             <div>	 the <code>MonoClass</code> pointer that describes the class that <i>type</i> represents.
</div>
             <div class="mapi-section">Description</div>
             <div>
 It is only valid to call this function if <i>type</i> is a <code>MONO_TYPE_CLASS</code> or a
 <code>MONO_TYPE_VALUETYPE</code> . For more general functionality, use <code>mono_class_from_mono_type</code>,
 instead.</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_get_modifiers"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_get_modifiers</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">MonoClass*
mono_type_get_modifiers (MonoType *type, gboolean *is_required, gpointer *iter)

</div>
            <p />
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_get_name"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_get_name</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">char*
mono_type_get_name (MonoType *type)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>type</i></td><td> a type</td></tr></tbody></table>             <div class="mapi-section">Return value</div>
             <div>	 The string representation for type as it would be represented in IL code.
</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_get_ptr_type"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_get_ptr_type</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">MonoType*
mono_type_get_ptr_type (MonoType *type)

</div>
            <p />
             <div class="mapi-section">Return value</div>
             <div>	 the <code>MonoType</code> pointer that describes the type that <i>type</i>

	 represents a pointer to.</div>
             <div class="mapi-section">Description</div>
             <div>
 \pararm type the <code>MonoType</code> operated on
 It is only valid to call this function if <i>type</i> is a <code>MONO_TYPE_PTR</code> .</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_get_signature"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_get_signature</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">MonoMethodSignature*
mono_type_get_signature (MonoType *type)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>type</i></td><td> the <code>MonoType</code> operated on</td></tr></tbody></table>             <div class="mapi-section">Return value</div>
             <div>	 the <code>MonoMethodSignature</code> pointer that describes the signature

	 of the function pointer <i>type</i> represents.</div>
             <div class="mapi-section">Description</div>
             <div>
 It is only valid to call this function if <i>type</i> is a <code>MONO_TYPE_FNPTR</code> .</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_get_type"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_get_type</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">int
mono_type_get_type (MonoType *type)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>type</i></td><td> the <code>MonoType</code> operated on</td></tr></tbody></table>             <div class="mapi-section">Return value</div>
             <div>	 the IL type value for <i>type</i>. This is one of the <code>MonoTypeEnum</code>

	 enum members like <code>MONO_TYPE_I4</code> or <code>MONO_TYPE_STRING</code>.</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_get_underlying_type"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_get_underlying_type</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">MonoType*
mono_type_get_underlying_type (MonoType *type)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>type</i></td><td> a type</td></tr></tbody></table>             <div class="mapi-section">Return value</div>
             <div>	 The <code>MonoType</code> for the underlying integer type if <i>type</i>

	 is an enum and byref is false, otherwise the type itself.</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_is_byref"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_is_byref</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">mono_bool
mono_type_is_byref (MonoType *type)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>type</i></td><td> the <code>MonoType</code> operated on</td></tr></tbody></table>             <div class="mapi-section">Return value</div>
             <div>	 <code>TRUE</code> if <i>type</i> represents a type passed by reference,

	 <code>FALSE</code> otherwise.</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_is_pointer"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_is_pointer</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">mono_bool
mono_type_is_pointer (MonoType *type)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>type</i></td><td> the <code>MonoType</code> operated on</td></tr></tbody></table>             <div class="mapi-section">Return value</div>
             <div>	 <code>TRUE</code> if <i>type</i> is a managed or unmanaged pointer type. <code>FALSE</code> otherwise.
</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_is_reference"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_is_reference</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">mono_bool
mono_type_is_reference (MonoType *type)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>type</i></td><td> the <code>MonoType</code> operated on</td></tr></tbody></table>             <div class="mapi-section">Return value</div>
             <div>	 <code>TRUE</code> if <i>type</i> represents an object reference. <code>FALSE</code> otherwise.
</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_is_struct"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_is_struct</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">mono_bool
mono_type_is_struct (MonoType *type)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>type</i></td><td> the <code>MonoType</code> operated on</td></tr></tbody></table>             <div class="mapi-section">Return value</div>
             <div>	 <code>TRUE</code> if <i>type</i> is a struct, that is a <code>ValueType</code> but not an enum

	 or a basic type like <code>System.Int32</code> . <code>FALSE</code> otherwise.</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_is_void"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_is_void</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">mono_bool
mono_type_is_void (MonoType *type)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>type</i></td><td> the <code>MonoType</code> operated on</td></tr></tbody></table>             <div class="mapi-section">Return value</div>
             <div>	 <code>TRUE</code> if <i>type</i> is <code>System.Void</code> . <code>FALSE</code> otherwise.
</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_size"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_size</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">int
mono_type_size (MonoType *t, int *align)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>t</i></td><td> the type to return the size of</td></tr></tbody></table>             <div class="mapi-section">Return value</div>
             <div>	 The number of bytes required to hold an instance of this

	 type in memory</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_stack_size"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_stack_size</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">int
mono_type_stack_size (MonoType *t, int *align)

</div>
            <p />
            <div class="mapi-section">Parameters</div>
            <table class="mapi-parameters"><tbody><tr><td><i>t</i></td><td> the type to return the size it uses on the stack</td></tr></tbody></table>             <div class="mapi-section">Return value</div>
             <div>	 The number of bytes required to hold an instance of this

	 type on the runtime stack</div>
        </div><!--mapi-description -->
    </div><!--height container -->
</div> <!-- class=mapi  -->

<a name="api:mono_type_to_unmanaged"></a>
<div class="mapi">
    <div class="mapi-entry "><code>mono_type_to_unmanaged</code></div>
    <div class="mapi-height-container">
        <div class="mapi-ptr-container"></div>
        <div class="mapi-description">
            <div class="mapi-ptr"></div>

            <div class="mapi-declaration mapi-section">Syntax</div>
            <div class="mapi-prototype">guint32
mono_type_to_unmanaged (MonoType *type, MonoMarshalSpec *mspec, gboolean as_field,
			gboolean unicode, MonoMarshalConv *conv) 

</div>
            <p />
             <div class="mapi-section">Return value</div>
             <div>	 A <code>MonoMarshalNative</code> enumeration value (<code>MONO_NATIVE_</code>) value

	 describing the underlying native reprensetation of the type.</div>
             <div class="mapi-section">Description</div>
             <div>
 The value pointed to by <i>conv</i> will contain the kind of marshalling required for this
 particular type one of the <code>MONO_MARSHAL_CONV_</code> enumeration values.</div>
        </div><!--mapi-description -->
    </div><!--height container -->
